﻿Public Class Form1

    'dies soll zeigen wie man einen mehrzeilig markierten Text um eine Tab-Position einrücken kann

    'Dieser Source-Code kann frei verwendet werden!
    'für evtl. auftretende Schäden wird nicht gehaftet
    '**********************************************************************************************
    Private Declare Function SendMessage Lib "USER32" Alias "SendMessageA" _
   (ByVal hwnd As Int32, ByVal wMsg As Int32, ByVal wParam As Int32, ByVal lParam As  _
   Int32) As Int32
    Public Const EM_SETSEL As Int32 = &HB1
    '**********************************************************************************************

    Private Sub ÖffnenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ÖffnenToolStripMenuItem.Click
        Try
            Dim myOpenFileDialog As New OpenFileDialog
            With myOpenFileDialog
                .Title = "Datei öffnen"
                .Filter = "Text-Dateien *.txt|*.txt|RichTextDateien *.rtf|*.rtf|alle Dateien *.*|*.*"
                If .ShowDialog = Windows.Forms.DialogResult.OK Then
                    If .FileName <> "" Then
                        Dim fileextension As String = Mid(.FileName, InStrRev(.FileName, "."))

                        Select Case StrConv(fileextension, VbStrConv.Lowercase)

                            Case ".txt"
                                Me.RichTextBox1.LoadFile(.FileName, RichTextBoxStreamType.PlainText)
                            Case ".rtf"
                                Me.RichTextBox1.LoadFile(.FileName, RichTextBoxStreamType.RichText)
                            Case Else

                                Dim fileReader As System.IO.StreamReader
                                Dim stringReader As String
                                fileReader = My.Computer.FileSystem.OpenTextFileReader(.FileName)

                                stringReader = fileReader.ReadToEnd()

                                With Me
                                    .RichTextBox1.Clear()
                                    .RichTextBox1.Text = stringReader
                                    fileReader.Close()
                                    My.Computer.FileSystem.OpenTextFileReader(myOpenFileDialog.FileName).Close()
                                End With

                        End Select
                    End If
                End If
                .Dispose()
            End With
        Catch ex As Exception

        End Try
    End Sub

    Private Sub RichTextBox1_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles RichTextBox1.KeyUp
        Try

            Select Case e.KeyCode
                Case Keys.Tab
                    Call makeTab()
            End Select

        Catch ex As Exception

        End Try
    End Sub

    Private Sub makeTab()
        With Me.RichTextBox1
            '**********************************************************************************************
            'kann so auch im HTML-Editor (VB 2008) ("HTML-Pad") in FrmEditor verwendet werden
            '**********************************************************************************************
            'Text um Tab-Bereich einrücken
            Dim sTabText As String = ""
            Dim strSelText As String = .SelectedText
            Dim lStartalt As Long = .SelectionStart
            Dim Zähler As Integer = -1

            Dim bExtraTab As Boolean = Not strSelText.EndsWith(vbLf)

            If InStr(strSelText, vbLf, CompareMethod.Binary) Then
                'mehrzeiligen markierten Text um Tab-Bereich einrücken

                'Array initialisieren und füllen
                Dim ArraySelText() As String = Split(strSelText, vbLf)
                'Variable für die entsprechende Wertaufnahme
                For i As Integer = 0 To ArraySelText.Length - 1
                    'hier werden auch leere Zeilen eingelesen
                    Zähler += 1
                    ArraySelText(Zähler) = ArraySelText(i)
                Next

                'Datenfeld ist nun mit den Werten gefüllt
                ReDim Preserve ArraySelText(Zähler)

                For n As Integer = 0 To UBound(ArraySelText)
                    If n < UBound(ArraySelText) Then
                        If ArraySelText(n).ToString <> "" Then
                            sTabText = sTabText & vbTab & ArraySelText(n).ToString & vbCrLf
                        Else
                            'leere Zeile
                            sTabText = sTabText & vbCrLf
                        End If
                    Else
                        If bExtraTab = False Then
                            sTabText = sTabText & ArraySelText(n).ToString
                        Else
                            sTabText = sTabText & vbTab & ArraySelText(n).ToString
                        End If
                    End If
                Next
            Else
                sTabText = vbTab & strSelText
            End If

            .SelectedText = sTabText
            If strSelText = "" Then
                'evtl den Cursor setzen
                .SelectionStart = lStartalt + Len(CStr(vbTab))
            Else
                'Markierung "beibehalten"
                'so kann durch mehrmaliges betätigen der Tab-Taste der Text eingerückt werden

                '.SelectionStart = lStartalt
                '.SelectionLength = Len(sTabText) - Zähler
                SendMessage(.Handle, EM_SETSEL, lStartalt, lStartalt + Len(sTabText) - Zähler)

            End If

            '**********************************************************************************************
            'Call Freeze()
            'Call HtmlColorCode(lStartalt, lStartalt + Len(sTabText), True)
            'Call Defrost()
            '**********************************************************************************************
            .Focus()
        End With
    End Sub

    Private Sub tbbtnTab_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbbtnTab.Click
        Call makeTab()
    End Sub

    Private Sub tbbtnUndo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbbtnUndo.Click
        With Me.RichTextBox1
            .Undo()
        End With
    End Sub

    Private Sub tbbtnRedo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbbtnRedo.Click
        With Me.RichTextBox1
            .Redo()
        End With
    End Sub
End Class
